#version 150

uniform vec3 lightPos0, lightPos1;
uniform vec4 drawColor;
uniform mat3 normalMatrix;
uniform mat4 modelViewMatrix, projectionMatrix;
uniform sampler2D textureID;

in vec2 textureCoord;
in vec3 lightDir0, normal;
in vec4 modelViewPos, color;

out vec4 outColor;

uniform int passNum;
uniform float ratio;
uniform float blurSize;

//const float blurSize = 1.0 / 512.0;
//float blurSize = 1.0 / 400.0;
//float w[4];
//float b[4];
const int s = 4;
const float w[s] = float[s](0.2098569157,0.3060413355,0.0834658188,0.0055643879);
const float b[s] = float[s](0.0,1.4,3.2666666667,5.0);

void hor(void) {
	vec4 sum = texture(textureID, vec2(textureCoord.s, textureCoord.t)) * w[0];
	for(int i=1;i<s;++i){
		sum +=  texture(textureID, vec2(textureCoord.s + ratio * b[i] * blurSize, textureCoord.t)) * w[i];
		sum +=  texture(textureID, vec2(textureCoord.s - ratio * b[i] * blurSize, textureCoord.t)) * w[i];
	}
	outColor = sum;
}

void ver(void) {
	vec4 sum = texture(textureID, vec2(textureCoord.s, textureCoord.t)) * w[0];
	for(int i=1;i<s;++i){
		sum += texture(textureID, vec2(textureCoord.s, textureCoord.t + b[i] * blurSize)) * w[i];
		sum += texture(textureID, vec2(textureCoord.s, textureCoord.t - b[i] * blurSize)) * w[i];
	}
	outColor = sum;
}

void main(void) {
	
	//w[0]=0.2734;
	//w[1]=0.2188;
	//w[2]=0.1094;
	//w[3]=0.0313;
	//w[4]=0.0039;
	
	/*
	w[0]=0.2270270270;
	w[1]=0.3162162162;
	w[2]=0.0702702703;
	b[0]=0.0;
	b[1]=1.3846153846;
	b[2]=3.2307692308;
	*/
	
	// THIS
	/*w[0]=0.2098569157;
	w[1]=0.3060413355;
	w[2]=0.0834658188;
	w[3]=0.0055643879;*/
	/*b[0]=0.0;
	b[1]=1.4;
	b[2]=3.2666666667;
	b[3]=5.0;*/
	/*w[0]=0.3807;
	w[1]=0.2437;
	w[2]=0.0609;
	w[3]=0.0050;
	w[4]=0.0001;*/
	if (passNum == 0) {
		hor();
	} else {
		ver();
	}
	
	// DEBUG: identity shader
	//outColor = texture(texture, vec2(v_texCoord.s, v_texCoord.t));
}