#version 150

in vec3 vertexPosition;
in vec4 vertexColor;
in vec3 vertexNormal;
in vec2 vertexTextureCoord;

uniform vec3 lightPos0, lightPos1;
uniform vec4 drawColor;
uniform mat3 normalMatrix;
uniform mat4 modelViewMatrix, projectionMatrix;
uniform sampler2D textureID;

out vec2 textureCoord;
out vec3 lightDir0, normal;
out vec4 modelViewPos, color;

void main(void) {
	textureCoord = vertexTextureCoord;
	gl_Position = projectionMatrix * modelViewMatrix * vec4(vertexPosition, 1.0);
}