#version 150

uniform vec3 lightPos0, lightPos1;
uniform vec4 drawColor;
uniform mat3 normalMatrix;
uniform mat4 modelViewMatrix, projectionMatrix;
uniform sampler2D textureID;

in vec2 textureCoord;

out vec4 outColor;

/*
 * Imagecolor determins orientation
 * Drawcolor determins rotation of orientation
 */
void main(void)
{
	// drawColor = 0.5 / 0.0
	vec2 rotCS = vec2(drawColor.x, drawColor.y) * 2.0 - 1.0; // 0.0 / -1.0
	vec2 rotSC = vec2(-rotCS.y, rotCS.x); // 1.0 / 0.0
	vec4 c = texture(textureID, textureCoord);
	// c = 1.0 / 0.5
	vec2 dir = c.xy * 2.0 - 1.0; // 1.0 / 0.0
	vec2 vn = rotCS * dir.x + rotSC * dir.y; // 0.0 / -1.0

	// Store values
	outColor = vec4((vn + 1.0) / 2.0, 0.0, c.z * drawColor.z); // 0.5 / 0.0
	//outColor = vec4(drawColor.xy, 0.0, c.a * drawColor.a);
	//outColor = vec4(c.xy, 0.0, c.a * drawColor.a);
}
