#version 150

in vec3 vertexPosition;
in vec2 vertexTextureCoord;

uniform mat4 modelViewMatrix, projectionMatrix;

out vec2 textureCoord, position;

void main(void) {
	// Store texCoord
	textureCoord = vertexTextureCoord;
	
	// Store screen position
	gl_Position = projectionMatrix * modelViewMatrix * vec4(vertexPosition, 1.0);
	position = gl_Position.xy / 2.0 + vec2(0.5, 0.5);
}