#version 150

in vec3 vertexPosition;
in vec4 vertexColor;
in vec3 vertexNormal;
in vec2 vertexTextureCoord;

uniform vec3 lightPos0, lightPos1;
uniform vec4 drawColor;
uniform mat3 normalMatrix;
uniform mat4 modelViewMatrix, projectionMatrix;
uniform sampler2D texture;

out vec2 v_texCoord;
out vec3 v_lightDir, v_normal;
out vec4 v_modelViewPos, v_color;

out vec2 tmpPos;

void main(void) {

	// Store screen position
	gl_Position = modelViewMatrix * vec4(vertexPosition, 1.0);

	vec3 shadowDir = gl_Position.xyz - lightPos1.xyz;
	shadowDir = shadowDir / shadowDir.z;
	
	gl_Position = gl_Position - vec4(shadowDir, 0.0) * gl_Position.z;

	// Store world position
	tmpPos = gl_Position.xy;

	gl_Position = projectionMatrix * gl_Position;

	// Store color
	//v_color = vertexColor; //why?
}