#version 150

in vec3 vertexPosition;
in vec4 vertexColor;
in vec3 vertexNormal;
in vec2 vertexTextureCoord;

uniform vec3 lightPos0, lightPos1;
uniform vec4 drawColor;
uniform mat3 normalMatrix;
uniform mat4 modelViewMatrix, projectionMatrix;
uniform sampler2D textureID;

out vec4 modelViewPos;

void main(void)
{
	// Store world position
	modelViewPos = modelViewMatrix * vec4(vertexPosition, 1.0);
	// Store screen position
	gl_Position = projectionMatrix * modelViewPos;
}